#ifndef HANOI_H
#define HANOI_H

#include <QMainWindow>
#include <piece.h>
#include <QDialog>
#include <qudpsocket.h>
#include <QGraphicsView>


#define Xw          450
#define Yw          150

#define MaxPieces   100


class Hanoi
    : public QMainWindow
{
    Q_OBJECT

public:
    // Constructor
                    Hanoi(QWidget *parent = 0);
                    ~Hanoi();

    // Initialize the game
    void            Init(int NbPieces);

    // Move a part
    int             MovePart(int From, int To);



private slots:
    // Process incomming socket
    void            processPendingDatagrams();



private:
    //
    int             ChangePart(int From, int To);
    void            DrawGame();

    QGraphicsScene  *scene;
    QGraphicsView   *vue;
    QUdpSocket      *udpSocket;
    Piece           Part[MaxPieces];


    double          PieceHeight;
    int             Game[3][MaxPieces+1];

};

#endif // HANOI_H
